use cmd_lib::*;

#[cmd_lib::main]
fn main() -> CmdResult {
    println!("hello");
    run_cmd!(echo -n "xxx" | wc)?;
    run_cmd!(echo  "xxx" | wc)?;
    run_cmd!(echo "aa bb" "no such file")?;
    run_cmd!(error "This is an error message")?;
    run_cmd!(warn "This is a warning message")?;
    // run_cmd!(echo "This is an infomation message" 2>/dev/null | ignore xfalse alarm)?;
    run_cmd!(echo "echo")?;
    run_cmd!(info "info")?;
    run_cmd!(warn "warn")?;
    run_cmd!(error "error")?;
    run_cmd!(trace "trace")?;
    run_cmd!(debug "debug")?;
    let mut p = spawn!(F=100 ls | wc)?;
    let pids = p.pids();
    dbg!(pids);
    p.wait()?;
    let opts = vec!["-l", "-a"];
    run_cmd!(ls $[opts])?;
    // let _ = spawn!(dfd xx </tmp/xf)?;
    // run_cmd!(cd /xx; fdisk - l / dev / nume | wc)?;
    let out = run_fun! {ignore du -ah . | sort -hr | head -n 5}?;
    println!("{}", out);
    dbg!(out);
    let res = run_fun!(ignore ls / /x 2>&1)?;
    dbg!(res);
    let out = run_fun!(echo "hello")?;
    dbg!(out);
    run_cmd!(cat LICENSE)?;
    let output = run_fun!(cat LICENSE)?;
    dbg!(output.len());

    run_cmd!(ignore cat LICENSE3 >&2)?;
    let output = run_fun!(ignore cat LICENSE3)?;
    dbg!(output.len());

    let _output = run_fun!(cat LICENSE3)?;
    run_cmd!(
        /bin/echo "hello0";
        echo "hello1";
        echo "hello2" >&2;
        info "hello3 and sleep";
        sleep 5;
        info "sleep back";
        echo "world";
    )?;
    cmd_die!("something is wrong");
}
